require 'flicks/movie'

module Flicks
	RSpec.describe(Movie) do
		before do 
			@initial_rank = 10
			@movie = Movie.new('goonies',@initial_rank)
		end

		it('has a capitalized title') do
			expect(@movie.title).to eq(@movie.title.capitalize)
		end

		it('has an initial rank') do
			expect(@movie.rank).to eq(10)
		end

		it('has a string representation') do
		 expect(@movie.to_s).to eq("#{@movie.title} has a rank of #{@movie.rank} (Hit)")
		end

		it('increases rank by 1 when given a thumbs up') do
			expect(@movie.thumbs_up).to eq(@initial_rank + 1)
		end

		it('decreases rank by 1 when given a thumbs down') do
			expect(@movie.thumbs_down).to eq(@initial_rank - 1)
		end

		context("created with default rank") do
			before do
				@movie = Movie.new('goonies')
			end

			it('has default value of 0') do
				expect(@movie.rank).to eq(0)
			end
		end
	end
end
