require 'flicks/playlist'
require 'flicks/waldorf_and_statler'

module Flicks
	RSpec.describe(Playlist) do 
		before do
			$stdout = StringIO.new
			@playlist = Playlist.new('Kermit')
		end

		context('being played with one movie') do
			before do
				@initial_rank = 10
				@movie = Movie.new('goonies',@initial_rank)
				@playlist.add_movie(@movie)
			end

			it('gives the movie a thumbs up if a high number is rolled') do
				allow(WaldorfAndStatler).to receive(:roll_die).and_return(5)
				@playlist.play(1)

				expect(@movie.rank).to eq(@initial_rank + 1)
			end

			it('skips the movie if medium number is rolled') do
				allow(WaldorfAndStatler).to receive(:roll_die).and_return(4)
				@playlist.play(1)

				expect(@movie.rank).to eq(@initial_rank)
			end

			it('gives the movie a thumbs down if low number is rolled') do
				allow(WaldorfAndStatler).to receive(:roll_die).and_return(0)
				@playlist.play(1)

				expect(@movie.rank).to eq(@initial_rank - 1)
			end
		end
	end
end
